########################################################################################################################
#
########################################################################################################################

require_relative 'abstract_reporter'

module Rproof
  class CompositeReporter < AbstractReporter
    def initialize
      @reporters = []
    end

    def add(reporter)
      @reporters << reporter
    end

    def report_campaign_begin
      @reporters.each { |r| r.report_campaign_begin }
    end

    def report_suite_begin(id, name, description)
      @reporters.each { |r| r.report_suite_begin id, name, description }
    end

    def report_test_begin(id, name, description)
      @reporters.each { |r| r.report_test_begin id, name, description }
    end

    def report_assertion(assertion)
      @reporters.each { |r| r.report_assertion assertion }
    end

    def report_warning(warning)
      @reporters.each { |r| r.report_warning warning }
    end

    def report_exception(exception)
      @reporters.each { |r| r.report_exception exception }
    end

    def report_test_end(id, test_result)
      @reporters.each { |r| r.report_test_end id, test_result }
    end

    def report_suite_end(id, test_results)
      @reporters.each { |r| r.report_suite_end id, test_results }
    end

    def report_campaign_end(test_results, start_time, end_time)
      @reporters.each { |r| r.report_campaign_end test_results, start_time, end_time }
    end
  end
end
