########################################################################################################################
# Run test or test suite with an associated reporter.
########################################################################################################################

require_relative 'test'
require_relative 'test_suite'
require_relative 'abstract_reporter'

module Rproof
  class TestRunner
    def initialize(reporter)
      raise "reporter is not an Abstract_Reporter" unless reporter.is_a? AbstractReporter
      @reporter = reporter
    end

    def run(test)
      start_time = Time.now
      @reporter.report_campaign_begin
      results = test.execute
      end_time = Time.now
      @reporter.report_campaign_end results, start_time, end_time
    end
  end
end
